---
title: XRInputSourcesChangeEvent()
slug: Web/API/XRInputSourcesChangeEvent/XRInputSourcesChangeEvent
tags:
  - API
  - AR
  - Change
  - Constructor
  - Input Sources
  - Inputs
  - Mixed
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourcesChangeEvent
  - augmented
---
<p>{{APIRef("WebXR Device API")}} {{SecureContext_Header}}</p>

<p><span class="seoSummary">The <code><strong>XRInputSourcesChangeEvent()</strong></code> constructor creates and returns a new {{domxref("XRInputSourcesChangeEvent")}} object, representing an update to the list of available <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR</a> input devices.</span> You won't typically call this constructor yourself, as these events are created and sent to you by the WebXR system.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>newInputSourcesChangeEvent</em> = new XRInputSourcesChangeEvent(<em>type</em>, <em>eventInitDict</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>type</code></dt>
 <dd>A {{domxref("DOMString")}} indicating the type of event which has occurred. This string must always be <code>inputsourceschange</code>.</dd>
 <dt><code>eventInitDict</code></dt>
 <dd>An object conforming to the {{domxref("XRInputSourcesChangeEventInit")}} dictionary, prodividing the initial values for the event.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A newly-created {{domxref("XRInputSourcesChangeEvent")}} object configured based upon the input parameters provided.</p>

<h2 id="Event_types">Event types</h2>

<p>{{page("/en-US/docs/Web/API/XRInputSourcesChangeEvent", "Event types")}}</p>

<h2 id="Example">Example</h2>

<p>The following snippet of code creates a new <code>XRInputSourcesChangeEvent</code> object indicating that a single new input source, described by an {{domxref("XRInputSource")}} object named <code>newInputSource</code>, has been added to the system.</p>

<pre class="brush: js">let iscEvent = new XRInputSourcesChangeEvent("inputsourceschange", { session: xrSession,
                           added: [newInputSource], removed: [] });
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrinputsourceschangeevent-xrinputsourceschangeevent","XRInputSourcesChangeEvent()")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRInputSourcesChangeEvent.XRInputSourcesChangeEvent")}}</div>
